#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(a) a.begin(), a.end()

using namespace std;

const int inf = 1000000000;
const int maxt = 3600;

vector <int> vals;

int djikstra(int t)
{
    vector <int> d(maxt + 1, inf);
    d[0] = 0;
    set<pair<int, int> > all;
    forn(i, d.size())
        all.insert(mp(d[i], i));
    while(!all.empty())
    {
        pair<int, int> v = *all.begin();
        all.erase(v);
        forn(i, vals.size())
        {
            int tv = v.sc + vals[i];
            if(tv < 0)
                tv = 0;
            if(tv > maxt)
                tv = maxt;
            if(v.fs + 1 < d[tv])
            {
                all.erase(mp(d[tv], tv));
                d[tv] = v.fs + 1;
                all.insert(mp(d[tv], tv));
            }
        }
    }
    for(int i = t; i <= maxt; ++i)
    {
        if(d[i] != inf)
        {
            cout << d[i] << " " << i - t << endl;
            return 0;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    forn(tt, t)
    {
        int n, t;
        cin >> n >> t;
        vals.resize(n);
        forn(i, n)
            cin >> vals[i];
        djikstra(t);
    }
    return 0;
}

