#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(a) a.begin(), a.end()

using namespace std;

const int MAXN = 100 * 1000 + 5;
int st[4 * MAXN];
pair<int, pair<int, int> > p[MAXN];

void update(int v, int tl, int tr, int pos, int val) {
    if(tl == tr - 1) {
        st[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if(pos < tm)
        update(2 * v, tl, tm, pos, val);
    else
        update(2 * v + 1, tm, tr, pos, val);
    st[v] = max(st[2 * v], st[2 * v + 1]);
}

int get(int v, int tl, int tr, int l, int r) {
    if(tl == l && tr == r)
        return st[v];
    int tm = (tl + tr) / 2, res0 = 0, res1 = 0;
    if(l < tm)
        res0 = get(2 * v, tl, tm, l, min(r, tm));
    if(r > tm)
        res1 = get(2 * v + 1, tm, tr, max(l, tm), r);
}

int main() {
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int n;
        cin >> n;
        for(int i = 0; i < n; i++) {
            cin >> p[i].first >> p[i].second.first >> p[i].second.second;
            p[i].first = n - p[i].first;
            p[i].second.first = n - p[i].second.first;
            p[i].second.second = n - p[i].second.second;
        }
        sort(p, p + n);
        for(int i = 0; i < 4 * n; i++)
            st[i] = 0;
        int ans = 0;
        for(int i = n - 1; i >= 0; i--) {
            int j = i;
            while(j >= 0 && p[i].first == p[j].first) {
                if(p[j].second.first == n - 1 || get(1, 0, n, p[j].second.first + 1, n) <= p[j].second.second)
                    ans++;
                j--;
            }
            int k = j;
            j++;
            while(j <= i) {
                update(1, 0, n, p[j].second.first, p[j].second.second);
                j++;
            }
            i = k + 1;
        }
        cout << ans << '\n';
    }
    return 0;
}

