#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

void solve()
{
    int n, T;
    cin >> n >> T;
    vi b(n); cin >> b;

    const int maxn = 3600 + 1;
    vvi g(maxn);
    forn(t, maxn)
    {
        forn(i, n)
        {
            int nt = t + b[i];
            nt = min(3600, nt);
            nt = max(0, nt);
            if (t != nt)
                g[t].push_back(nt);
        }
    }

    queue<int> q; q.push(0);
    vi dist(maxn, -1); dist[0] = 0;
    while (q.size())
    {
        int u = q.front(); q.pop();
        forn(i, g[u].size())
        {
            int v = g[u][i];
            if (dist[v] == -1)
            {
                dist[v] = dist[u] + 1;
                q.push(v);
            }
        }
    }

    if (dist[T] != -1)
    {
        cout << dist[T] << " " << 0 << endl;
    }
    else
    {
        for (int i = T + 1; i < maxn; ++i)
            if (dist[i] != -1)
            {
                cout << dist[i] << " " << i - T << endl;
                return;
            }
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    ios_base::sync_with_stdio(false);

    int t; cin >> t;
    while (t--)
        solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif