#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

struct st_t
{
    int r1, r2, r3;
    void read() { scanf("%d %d %d", &r1, &r2, &r3); --r1, --r2, --r3; }
    friend bool operator < (const st_t &a, const st_t &b)
    {
        return a.r1 < b.r1;
    }
};

class segm_tree_t
{
    int n;
    vi t;
    int get(int v, int tl, int tr, int l, int r)
    {
        if (l > r)
            return inf;
        if (tl == l && tr == r)
            return t[v];
        int tm = (tl + tr) / 2;
        int v1 = get(2 * v + 1, tl, tm, l, min(r, tm));
        int v2 = get(2 * v + 2, tm + 1, tr, max(l, tm + 1), r);
        return min(v1, v2);
    }
    void upd(int v, int tl, int tr, int idx, int val)
    {
        if (tl == tr)
            t[v] = val;
        else
        {
            int tm = (tl + tr) / 2;
            if (idx <= tm)
                upd(2 * v + 1, tl, tm, idx, val);
            else
                upd(2 * v + 2, tm + 1, tr, idx, val);
            t[v] = min(t[2 * v + 1], t[2 * v + 2]);
        }
    }

public:
    segm_tree_t(int n) : n(n) { t.assign(4 * n, inf); }
    void upd(int idx, int val) { upd(0, 0, n - 1, idx, val); }
    int get(int l, int r) { return get(0, 0, n - 1, l, r); }
};

void solve()
{
    int n; scanf("%d", &n);
    vector<st_t> a(n);
    forn(i, n)
        a[i].read();

    segm_tree_t st(n);
    sort(all(a));
    vi good(n, true);
    forn(i, n)
    {
        if (st.get(0, a[i].r2) <= a[i].r3)
            good[i] = false;
        st.upd(a[i].r2, a[i].r3);
    }

    int res = accumulate(all(good), 0);
    printf("%d\n", res);
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);

    int t; scanf("%d", &t);
    while (t--)
        solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif