#if 1
#include <cstdio>
#include <cstring>
#include <cassert>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define X first
#define Y second

typedef long long li;
typedef long double ld;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;

struct man
{
	int a, b, c;
	man() {}
	man(int a, int b, int c) : a(a), b(b), c(c) {}
	friend bool operator < (const man &one, const man &two)
	{
		return one.a < two.a;
	}
};

struct fenv_s
{
	vi arr;
	fenv_s(int n)
	{
		arr.assign(n, 1e6);
	}
	int getmin(int r)
	{
		int result = 1e6;
		for (; r >= 0; r = (r & (r + 1) ) - 1)
			result = min(result, arr[r]);
		return result;
	}
	void setval(int i, int v)
	{
		for (; i < arr.size(); i = i | (i + 1))
		{
			arr[i] = min(arr[i], v);
		}
	}
};

int main()
 {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int T; scanf("%d", &T);
	for (int t = 1; t <= T; ++t)
	{
		int n; scanf("%d", &n);
		vector<man> mans(n);
		for (int i = 0; i < n; ++i)
		{
			scanf("%d%d%d", &mans[i].a, &mans[i].b, &mans[i].c);
			mans[i].a--; mans[i].b--; mans[i].c--;
		}
		sort(mans.begin(), mans.end());
		int answer = 0;
		fenv_s F(n);
		for (int i = 0; i < n; ++i)
		{
			int xmin = F.getmin(mans[i].b);
			if(xmin > mans[i].c)
			{
				answer++;
				F.setval(mans[i].b, mans[i].c);
			}
		}
		printf("%d\n", answer);
	}
	return 0;
}
#endif